xref: /freebsd/share/examples/hast/ucarp_up.sh (revision abd87254)
1#!/bin/sh
2#
3# SPDX-License-Identifier: BSD-2-Clause
4#
5# Copyright (c) 2010 The FreeBSD Foundation
6# All rights reserved.
7#
8# This software was developed by Pawel Jakub Dawidek under sponsorship from
9# the FreeBSD Foundation.
10#
11# Redistribution and use in source and binary forms, with or without
12# modification, are permitted provided that the following conditions
13# are met:
14# 1. Redistributions of source code must retain the above copyright
15#    notice, this list of conditions and the following disclaimer.
16# 2. Redistributions in binary form must reproduce the above copyright
17#    notice, this list of conditions and the following disclaimer in the
18#    documentation and/or other materials provided with the distribution.
19#
20# THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
21# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
22# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
23# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
24# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
25# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
26# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
27# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
28# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
29# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
30# SUCH DAMAGE.
31#
32
33# Resource name as defined in /etc/hast.conf.
34resource="test"
35# Supported file system types: UFS, ZFS
36fstype="UFS"
37# ZFS pool name. Required only when fstype == ZFS.
38pool="test"
39# File system mount point. Required only when fstype == UFS.
40mountpoint="/mnt/test"
41# Name of HAST provider as defined in /etc/hast.conf.
42device="/dev/hast/${resource}"
43
44export PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin
45
46# If there is secondary worker process, it means that remote primary process is
47# still running. We have to wait for it to terminate.
48for i in `jot 30`; do
49	pgrep -f "hastd: ${resource} \(secondary\)" >/dev/null 2>&1 || break
50	sleep 1
51done
52if pgrep -f "hastd: ${resource} \(secondary\)" >/dev/null 2>&1; then
53	logger -p local0.error -t hast "Secondary process for resource ${resource} is still running after 30 seconds."
54	exit 1
55fi
56logger -p local0.debug -t hast "Secondary process in not running."
57
58# Change role to primary for our resource.
59out=`hastctl role primary "${resource}" 2>&1`
60if [ $? -ne 0 ]; then
61	logger -p local0.error -t hast "Unable to change to role to primary for resource ${resource}: ${out}."
62	exit 1
63fi
64# Wait few seconds for provider to appear.
65for i in `jot 50`; do
66	[ -c "${device}" ] && break
67	sleep 0.1
68done
69if [ ! -c "${device}" ]; then
70	logger -p local0.error -t hast "Device ${device} didn't appear."
71	exit 1
72fi
73logger -p local0.debug -t hast "Role for resource ${resource} changed to primary."
74
75case "${fstype}" in
76UFS)
77	# Check the file system.
78	fsck -y -t ufs "${device}" >/dev/null 2>&1
79	if [ $? -ne 0 ]; then
80		logger -p local0.error -t hast "File system check for resource ${resource} failed."
81		exit 1
82	fi
83	logger -p local0.debug -t hast "File system check for resource ${resource} finished."
84	# Mount the file system.
85	out=`mount -t ufs "${device}" "${mountpoint}" 2>&1`
86	if [ $? -ne 0 ]; then
87		logger -p local0.error -t hast "File system mount for resource ${resource} failed: ${out}."
88		exit 1
89	fi
90	logger -p local0.debug -t hast "File system for resource ${resource} mounted."
91	;;
92ZFS)
93	# Import ZFS pool. Do it forcibly as it remembers hostid of
94	# the other cluster node.
95	out=`zpool import -f "${pool}" 2>&1`
96	if [ $? -ne 0 ]; then
97		logger -p local0.error -t hast "ZFS pool import for resource ${resource} failed: ${out}."
98		exit 1
99	fi
100	logger -p local0.debug -t hast "ZFS pool for resource ${resource} imported."
101	;;
102esac
103
104logger -p local0.info -t hast "Successfully switched to primary for resource ${resource}."
105
106exit 0
107